<template>
  <q-page padding>
    <div class="text-center">
      <q-img class="gt-xs" src="public/img/openscouts.png" width="20%"></q-img>
    </div>
    <br class="gt-xs" />
    <q-banner rounded class="bg-blue-grey-13 text-white">
      Mi Rincón es administrado por miembros de los scouts de manera voluntaria
      y sin recibir ninguna compensación económica por servicios o
      mantenimiento. Dado que este sistema es utilizado por múltiples zonas en
      el país, los administradores no respondemos a consultas relacionadas con
      la formación. Les solicitamos que, en caso de cualquier inconveniente o
      inquietud con respecto a su formación, se comuniquen con su Facilitador,
      ADAMS o AZAMS correspondiente. El correo electrónico
      soporte{@}mirincon.com.ar solo se ocupará de solicitudes de los AZAMS.
      <br />
      <strong class="float-right">
        ¡Siempre Listo!<br />
        Equipo Mi Rincón.
      </strong>
    </q-banner>
    <br class="gt-xs" />
    <br class="gt-xs" />
    <div class="q-gutter-sm">
      <!---------------------- Validacion Usuario ! ---------------------->
      <q-form @submit="validarDocumento" v-if="!organismos">
        <q-input
          autofocus
          v-model="formData.documento"
          label="Nro de Documento*"
          :error="validacion.has('documento')"
          :error-message="validacion.first('documento')"
          type="number"
        >
          <template v-slot:prepend>
            <q-icon name="person" />
          </template>
        </q-input>
        <br />
        <q-btn
          @click="validarDocumento"
          class="full-width"
          color="green"
          unelevated
        >
          (Ingresar) Validar Documento
        </q-btn>
      </q-form>
      <!---------------------- Seleccion Organismo y Password ! ---------------------->

      <q-form @submit="onSubmit" v-if="organismos">
        <q-input
          autofocus
          type="password"
          v-model="formData.password"
          label="Contraseña *"
          lazy-rules
          :error="validacion.has('password')"
          :error-message="validacion.first('password')"
          :rules="[
            (val) =>
              (val !== null && val !== '') || 'Por favor ingrese su contraseña',
          ]"
        >
          <template v-slot:prepend>
            <q-icon name="lock" />
          </template>
        </q-input>

        <q-select
          v-model="formData.organismo"
          :options="organismos"
          emit-value
          map-options
          label="Organismos"
          :error="validacion.has('organismo')"
          :error-message="validacion.first('organismo')"
        />
        <br />

        <q-btn
          @click="onSubmit"
          class="full-width"
          label="Ingresar a la plataforma"
          color="green"
          unelevated
        />
      </q-form>
    </div>
    <!---------------------- Link de Registros ! ---------------------->
    <div class="q-mt-sm q-mb-sm">
      <q-btn
        size="xs"
        color="red"
        v-if="organismos"
        class="text-withe full-width"
        label="Recuperar Clave"
        @click="onRecuperarClave"
        unelevated
      />
    </div>

    <q-banner class="bg-deep-purple text-white text-center" rounded>
      <p class="text-h5">Soy Nuevo</p>
      Los nuevos educadores deben registrarse por primera vez.
      <template v-slot:action>
        <q-btn
          color="blue"
          class="text-withe full-width"
          label="REGISTRATE !"
          to="/registro"
          unelevated
        />
      </template>
    </q-banner>

    <Loading :showing="loading" text="Validando Documento" />
  </q-page>
</template>

<script lang="ts">
import { reactive, defineComponent, ref } from 'vue';
import { useUserStore, UsuarioInterface } from 'src/stores/user';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { showErrorNotification } from 'src/functions/function-show-notifications';
import Loading from 'src/components/Loading.vue';
import { useQuasar } from 'quasar';
import { useRouter } from 'vue-router';

export default defineComponent({
  components: { Loading },
  setup() {
    const $q = useQuasar();
    const router = useRouter();

    const store = useUserStore();
    const loading = ref(false);
    const formData: UsuarioInterface = reactive<UsuarioInterface>({
      documento: null,
      password: '',
      organismo: null,
    });
    const organismos = ref(null);
    function validarDocumento() {
      loading.value = true;
      if (formData.documento == null || formData.documento < 999999) {
        showErrorNotification('Debe ingresar un nro de documento valido');
        loading.value = false;
        return;
      }

      api
        .post('/api/auth/get_organismos', { documento: formData.documento })
        .then((response: AxiosResponse) => {
          organismos.value = response.data;
          // no puedo definir un organismo x defecto, porque si no cuand hace el post envia el objeto entero
          formData.organismo = response.data[0].value;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function onSubmit() {
      if (formData.organismo == null || formData.organismo == '') {
        showErrorNotification('Debe seleccionar un organismo');
        return;
      }
      if (formData.password == null || formData.password == '') {
        showErrorNotification('Debe ingresar una contraseña');
        return;
      }
      store.login(formData);
    }

    function onRecuperarClave() {
      $q.dialog({
        title: 'Confirm',
        message: 'Esta Seguro que quiere cambiar la Clave ?',
        cancel: true,
        persistent: true,
      })
        .onOk(() => {
          loading.value = true;

          api.post('/api/auth/recuper_clave', formData).finally(() => {
            loading.value = false;
            router.push({ path: '/' });
          });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        })
        .onDismiss(() => {
          // console.log('I am triggered on both OK and Cancel')
        });
    }

    return {
      organismos,
      formData,
      validacion,
      loading,
      onSubmit,
      validarDocumento,
      onRecuperarClave,
    };
  },
});
</script>
